/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	danmv1 "github.com/nokia/danm/crd/apis/danm/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDanmEps implements DanmEpInterface
type FakeDanmEps struct {
	Fake *FakeDanmV1
	ns   string
}

var danmepsResource = schema.GroupVersionResource{Group: "danm.k8s.io", Version: "v1", Resource: "danmeps"}

var danmepsKind = schema.GroupVersionKind{Group: "danm.k8s.io", Version: "v1", Kind: "DanmEp"}

// Get takes name of the danmEp, and returns the corresponding danmEp object, and an error if there is any.
func (c *FakeDanmEps) Get(ctx context.Context, name string, options v1.GetOptions) (result *danmv1.DanmEp, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(danmepsResource, c.ns, name), &danmv1.DanmEp{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmEp), err
}

// List takes label and field selectors, and returns the list of DanmEps that match those selectors.
func (c *FakeDanmEps) List(ctx context.Context, opts v1.ListOptions) (result *danmv1.DanmEpList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(danmepsResource, danmepsKind, c.ns, opts), &danmv1.DanmEpList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &danmv1.DanmEpList{ListMeta: obj.(*danmv1.DanmEpList).ListMeta}
	for _, item := range obj.(*danmv1.DanmEpList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested danmEps.
func (c *FakeDanmEps) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(danmepsResource, c.ns, opts))

}

// Create takes the representation of a danmEp and creates it.  Returns the server's representation of the danmEp, and an error, if there is any.
func (c *FakeDanmEps) Create(ctx context.Context, danmEp *danmv1.DanmEp, opts v1.CreateOptions) (result *danmv1.DanmEp, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(danmepsResource, c.ns, danmEp), &danmv1.DanmEp{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmEp), err
}

// Update takes the representation of a danmEp and updates it. Returns the server's representation of the danmEp, and an error, if there is any.
func (c *FakeDanmEps) Update(ctx context.Context, danmEp *danmv1.DanmEp, opts v1.UpdateOptions) (result *danmv1.DanmEp, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(danmepsResource, c.ns, danmEp), &danmv1.DanmEp{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmEp), err
}

// Delete takes name of the danmEp and deletes it. Returns an error if one occurs.
func (c *FakeDanmEps) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(danmepsResource, c.ns, name), &danmv1.DanmEp{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDanmEps) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(danmepsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &danmv1.DanmEpList{})
	return err
}

// Patch applies the patch and returns the patched danmEp.
func (c *FakeDanmEps) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *danmv1.DanmEp, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(danmepsResource, c.ns, name, pt, data, subresources...), &danmv1.DanmEp{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmEp), err
}
