/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	danmv1 "github.com/nokia/danm/crd/apis/danm/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDanmNets implements DanmNetInterface
type FakeDanmNets struct {
	Fake *FakeDanmV1
	ns   string
}

var danmnetsResource = schema.GroupVersionResource{Group: "danm.k8s.io", Version: "v1", Resource: "danmnets"}

var danmnetsKind = schema.GroupVersionKind{Group: "danm.k8s.io", Version: "v1", Kind: "DanmNet"}

// Get takes name of the danmNet, and returns the corresponding danmNet object, and an error if there is any.
func (c *FakeDanmNets) Get(ctx context.Context, name string, options v1.GetOptions) (result *danmv1.DanmNet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(danmnetsResource, c.ns, name), &danmv1.DanmNet{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmNet), err
}

// List takes label and field selectors, and returns the list of DanmNets that match those selectors.
func (c *FakeDanmNets) List(ctx context.Context, opts v1.ListOptions) (result *danmv1.DanmNetList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(danmnetsResource, danmnetsKind, c.ns, opts), &danmv1.DanmNetList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &danmv1.DanmNetList{ListMeta: obj.(*danmv1.DanmNetList).ListMeta}
	for _, item := range obj.(*danmv1.DanmNetList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested danmNets.
func (c *FakeDanmNets) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(danmnetsResource, c.ns, opts))

}

// Create takes the representation of a danmNet and creates it.  Returns the server's representation of the danmNet, and an error, if there is any.
func (c *FakeDanmNets) Create(ctx context.Context, danmNet *danmv1.DanmNet, opts v1.CreateOptions) (result *danmv1.DanmNet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(danmnetsResource, c.ns, danmNet), &danmv1.DanmNet{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmNet), err
}

// Update takes the representation of a danmNet and updates it. Returns the server's representation of the danmNet, and an error, if there is any.
func (c *FakeDanmNets) Update(ctx context.Context, danmNet *danmv1.DanmNet, opts v1.UpdateOptions) (result *danmv1.DanmNet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(danmnetsResource, c.ns, danmNet), &danmv1.DanmNet{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmNet), err
}

// Delete takes name of the danmNet and deletes it. Returns an error if one occurs.
func (c *FakeDanmNets) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(danmnetsResource, c.ns, name), &danmv1.DanmNet{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDanmNets) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(danmnetsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &danmv1.DanmNetList{})
	return err
}

// Patch applies the patch and returns the patched danmNet.
func (c *FakeDanmNets) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *danmv1.DanmNet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(danmnetsResource, c.ns, name, pt, data, subresources...), &danmv1.DanmNet{})

	if obj == nil {
		return nil, err
	}
	return obj.(*danmv1.DanmNet), err
}
